# DAdaQuant: Communication-efficient Federated learning with adaptive quantization

This repository contains the source code for the paper "DAdaQuant:
Communication-efficient Federated Learning with adaptive quantization".

## Reproduction of results

We bundle our source code, dependencies and datasets into a self-contained
Docker image. Please use this Docker image to reproduce our results. The
following three sections describe how to install the docker image and
reproduce the plots from the paper.

### Installing the Docker image

The following instructions assume that you are using Linux on a workstation
with NVidia GPUs.

1. Install nvidia-docker https://docs.nvidia.com/datacenter/cloud-native/container-toolkit/install-guide.html#docker.

2. Run `docker run -it --gpus all --network="host" anonymous4123/repository:v3`  
   You should now be in an interactive Docker shell in our Docker image.

3. Run
   ```
   source /root/.pyenv/plugins/pyenv-virtualenv/shims/activate flower  
   cd dadaquant
   ```
   You are now ready for the next section.

### Reproducing plots from the paper.

Launch the Jupyter notebook `notebooks/results.ipynb`.
Execute the notebook from top to bottom. The notebook contains
several sections titled `[Experiments]`. Each such section lists
severl experiment IDs required to reproduce a plot or table from
the paper. In the Docker shell, execute each experiment with
`python src/scripts/run_experiment.py <experiment-id>`.
The results are logged in the directory `experiments`. Copy over
`experiments` from Docker to replace the `experiments` directory
on your workstation that runs the Jupyter notebook. You should
now be able to execute the Jupyter notebook cells for your section
and reproduce the table/plot.

#### *Note: Celeba experiments.*

Due to licensing restrictions, we are unable to include the Celeba dataset.
To run Celeba experiments, follow these steps:

1. Download the files identity_CelebA.txt, list_attr_celeba.txt and the
   folder img_align_celeba from
   http://mmlab.ie.cuhk.edu.hk/projects/CelebA.html into
   `dadaquant/leaf/data/celeba/data/raw`.
2. Run
   ```sh
   sh lefa/data/celeba/preprocess.sh
   python src/scripts/extract_celeba_data.py
   ```
   You should now be able to run Celeba experiments.


## Acknowledgements

This repository includes source code from the following projects:

* [FedProx](https://github.com/litian96/FedProx/), published under the MIT License.

* [Flower](https://github.com/adap/flower), published under the Apache License 2.0.